// AVAILABLE CHECK TYPES
//    PICOTEST_ASSERT(check1);
//    PICOTEST_VERIFY(0, "BETA");
//    PICOTEST_ABORT();

int emptyB[3][3] = {
        { BLANK, BLANK, BLANK },
        { BLANK, BLANK, BLANK },
        { BLANK, BLANK, BLANK }
};
int finishedB1[3][3] = {
        { playerX, playerX, playerX },
        { playerO, playerO, playerX },
        { playerO, playerO, playerX }
};

int finishedB2bad[3][3] = {
        { playerX, playerX, playerX },
        { playerO, playerO, playerX },
        { playerX, playerO, playerX }
};

int finishedB3bad[3][3] = {
        { playerX, playerX, playerO },
        { playerO, playerO, playerX },
        { playerO, playerO, playerX }
};

int NOTfinishedB4bad[3][3] = {
        { playerX, playerX,   BLANK },
        { playerO,   BLANK, playerX },
        {   BLANK, playerO, playerX }
};

int NOTfinishedB5bad[3][3] = {
        { playerX, playerX,   BLANK },
        {   BLANK,   BLANK, playerX },
        {   BLANK, playerO, playerX }
};

int NOTfinishedB6bad[3][3] = {
        { playerX, playerO,   BLANK },
        {   BLANK,   BLANK, playerO },
        {   BLANK, playerO, playerX }
};

int unfinishedB7playsX[3][3] = {
        { playerO,   BLANK, BLANK },
        {   BLANK, playerX, BLANK },
        {   BLANK,   BLANK, BLANK },
};

int unfinishedB8playsO[3][3] = {
        { playerO,   BLANK, BLANK },
        {   BLANK, playerX, BLANK },
        { playerX,   BLANK, BLANK },
};

int brokenB9[3][3] = {
        { playerX, playerO,   BLANK },
        {   BLANK,       3, playerX },
        {   BLANK, playerO, playerX }
};

int playNwinXat00B10[3][3] = {
        { BLANK, playerX, playerX },
        { BLANK, playerO, playerO },
        { BLANK,   BLANK,   BLANK }
};

int playNwinOat10B11[3][3] = {
        { BLANK, playerX, playerX },
        { BLANK, playerO, playerO },
        { BLANK,   BLANK, playerX }
};

int playNwinOat22B12[3][3] = {
        { playerO, playerX, playerO },
        {   BLANK, playerO, playerX },
        { playerX, playerX,   BLANK }
};

PICOTEST_SUITE(mainSuite, FINISHED, PLAYABLE, CAN_PLAY, RC2INT, MOVEnWIN)
PICOTEST_CASE(FINISHED) {
    PICOTEST_VERIFY(isFinished(finishedB1), "A finished board is not detected (XXX|OOX|OOX)")
    PICOTEST_VERIFY(isFinished(finishedB2bad), "A (bad) finished board is not detected (XXX|OOX|XOX)")
    PICOTEST_VERIFY(isFinished(finishedB3bad), "A (bad) finished board is not detected (XXO|OOX|OOX)")
    PICOTEST_VERIFY(!isFinished(NOTfinishedB4bad), "An unfinished board is not detected (XX-|O-X|-OX)")
    PICOTEST_VERIFY(!isFinished(NOTfinishedB5bad), "A (bad) unfinished board is not detected (XX-|--X|-OX)")
    PICOTEST_VERIFY(!isFinished(NOTfinishedB6bad), "A (bad) unfinished board is not detected (XO-|--O|-OX)")
}

PICOTEST_CASE(PLAYABLE) {
    PICOTEST_VERIFY(isPlayablePos(emptyB, 1,1), "An empty board (---|---|---) isn't playable at 1,1 ?!")
    PICOTEST_VERIFY(isPlayablePos(emptyB, 2,0), "An empty board (---|---|---) isn't playable at 2,0 ?!")
    PICOTEST_VERIFY(isPlayablePos(emptyB, 0,2), "An empty board (---|---|---) isn't playable at 0,2 ?!")
    PICOTEST_VERIFY(!isPlayablePos(emptyB, 0,3), "An empty board (---|---|---) is playable at 0,3 ?!")
    PICOTEST_VERIFY(!isPlayablePos(emptyB, 3,1), "An empty board (---|---|---) is playable at 3,1 ?!")
    PICOTEST_VERIFY(!isPlayablePos(finishedB1, 1,1), "A finished board (XXX|OOX|OOX) is playable at 1,1 ?!")
    PICOTEST_VERIFY(!isPlayablePos(finishedB1, 4,4), "A finished board (XXX|OOX|OOX) is playable at 4,4 ?!")
    PICOTEST_VERIFY(!isPlayablePos(finishedB2bad, 4,4), "A (bad) finished board (XXX|OOX|XOX) is playable at 4,4 ?!")
    PICOTEST_VERIFY(!isPlayablePos(finishedB2bad, 1,1), "A (bad) finished board (XXX|OOX|XOX) is playable at 1,1 ?!")
    PICOTEST_VERIFY(isPlayablePos(NOTfinishedB4bad, 1, 1), "An unfinished board (XX-|O-X|-OX) isn't playable at 1,1 ?!")
    PICOTEST_VERIFY(!isPlayablePos(NOTfinishedB4bad, 0, 0), "An unfinished board (XX-|O-X|-OX) is playable at 0,0 ?!")
    PICOTEST_VERIFY(isPlayablePos(NOTfinishedB5bad,1,0), "A (bad-it's ok) unfinished board (XX-|--X|-OX) isn't playable at 1,0")
    PICOTEST_VERIFY(!isPlayablePos(NOTfinishedB5bad,0,1), "A (bad-it's ok) unfinished board (XX-|--X|-OX) is playable at 0,1")
}

PICOTEST_CASE(CAN_PLAY) {
    PICOTEST_VERIFY(canPlay(emptyB,0,0,playerX),"An empty board cannot play X at 0,0!")
    PICOTEST_VERIFY(!canPlay(emptyB,0,3,playerX),"An empty board can play X at 0,3!")
    PICOTEST_VERIFY(!canPlay(emptyB,3,0,playerX),"An empty board can play X at 3,0!")
    PICOTEST_VERIFY(!canPlay(emptyB,1,1,playerO),"An empty board can play O at 1,1!")
    PICOTEST_VERIFY(canPlay(emptyB,2,2,playerX),"An empty board cannot play X at 2,2!")
    PICOTEST_VERIFY(!canPlay(finishedB3bad,1,2,playerX),"An finished bad board (XXO|OOX|OOX) can play X at 1,2!")
    PICOTEST_VERIFY(!canPlay(finishedB3bad,2,1,playerX),"An finished bad board (XXO|OOX|OOX) can play O at 2,1!")
    PICOTEST_VERIFY(canPlay(unfinishedB7playsX,2,0,playerX),"Board (O--|-X-|---) cannot play X at 2,0!")
    PICOTEST_VERIFY(!canPlay(unfinishedB7playsX,2,0,playerO),"Board (O--|-X-|---) can play O at 2,0!")
    PICOTEST_VERIFY(!canPlay(unfinishedB8playsO,2,0,playerX),"Board (O--|-X-|X--) can play X at 2,0!")
    PICOTEST_VERIFY(canPlay(unfinishedB8playsO,0,2,playerO),"Board (O--|-X-|X--) cannot play O at 0,2!")
    PICOTEST_VERIFY(!canPlay(brokenB9,0,2,playerO),"Board (XO-|-3X|-OX) can play O at 0,2!")
}

PICOTEST_CASE(RC2INT) {
    PICOTEST_VERIFY(rc2int(0,0) == 0 ,"rc2int didn't convert 0,0 to 0")
    PICOTEST_VERIFY(rc2int(0,1) == 1 ,"rc2int didn't convert 0,1 to 1")
    PICOTEST_VERIFY(rc2int(0,2) == 2 ,"rc2int didn't convert 0,2 to 2")
    PICOTEST_VERIFY(rc2int(1,0) == 10 ,"rc2int didn't convert 1,0 to 10")
    PICOTEST_VERIFY(rc2int(1,1) == 11 ,"rc2int didn't convert 1,1 to 11")
    PICOTEST_VERIFY(rc2int(1,2) == 12 ,"rc2int didn't convert 1,2 to 12")
    PICOTEST_VERIFY(rc2int(2,0) == 20 ,"rc2int didn't convert 2,0 to 20")
    PICOTEST_VERIFY(rc2int(2,1) == 21 ,"rc2int didn't convert 2,1 to 21")
    PICOTEST_VERIFY(rc2int(2,2) == 22 ,"rc2int didn't convert 2,2 to 22")
    PICOTEST_VERIFY(rc2int(-1,1) == -1 ,"rc2int didn't convert -1,1 to -1")
    PICOTEST_VERIFY(rc2int(-1,-1) == -1 ,"rc2int didn't convert -1,-1 to -1")
    PICOTEST_VERIFY(rc2int(1,-1) == -1 ,"rc2int didn't convert 1,-1 to -1")
    PICOTEST_VERIFY(rc2int(3,1) == -1 ,"rc2int didn't convert 3,1 to -1")
    PICOTEST_VERIFY(rc2int(3,3) == -1 ,"rc2int didn't convert 3,3 to -1")
    PICOTEST_VERIFY(rc2int(1,3) == -1 ,"rc2int didn't convert 1,3 to -1")
}

PICOTEST_CASE(MOVEnWIN) {
    PICOTEST_VERIFY(winningMove(emptyB)==-1,"Found winning move at empty board or considered it as bad!")
    PICOTEST_VERIFY(winningMove(finishedB1)==-2,"Found winning move at finished board (XXX|OOX|OOX)!")
    PICOTEST_VERIFY(winningMove(finishedB2bad)==-2,"Found winning move at finished bad board (XXX|OOX|XOX)!")
    PICOTEST_VERIFY(winningMove(finishedB3bad)==-2,"Found winning move at finished bad board! (XXO|OOX|OOX)")
    PICOTEST_VERIFY(winningMove(NOTfinishedB4bad) == -2, "Found winning move at unfinished bad board! (XX-|O-X|-OX)")
    PICOTEST_VERIFY(winningMove(NOTfinishedB5bad)==-2,"Found winning move at finished bad board or considered it as good! (XX-|--X|-OX)")
    PICOTEST_VERIFY(winningMove(NOTfinishedB6bad)==-2,"Found winning move at finished bad board or considered it as good! (XO-|--O|-OX)")
    PICOTEST_VERIFY(winningMove(unfinishedB7playsX)==-1,"Found winning move at unfinished early game board! (O--|-X-|---)")
    PICOTEST_VERIFY(winningMove(unfinishedB8playsO)==-1,"Found winning move at unfinished board! (O--|-X-|X--)")
    PICOTEST_VERIFY(winningMove(brokenB9)==-2,"NOT Found winning move at unfinished board! (O--|-X-|X--)")
    PICOTEST_VERIFY(winningMove(playNwinXat00B10)==0,"NOT Found winning move of X at unfinished board! (-XX|-OO|---)")
    PICOTEST_VERIFY(winningMove(playNwinOat10B11)==10,"NOT Found winning move of O at unfinished board! (-XX|-OO|--X)")
    PICOTEST_VERIFY(winningMove(playNwinOat22B12)==22,"NOT Found winning move of X at unfinished board! (OXO|-OX|XX-)")
}
